class CheckPoint expands Decoration;

#exec TEXTURE IMPORT NAME=DefaultCpoint FILE=Textures\DefaultCpoint.bmp

#exec mesh import mesh=CheckpointMesh anivfile=Models\CheckpointMesh_a.3d datafile=Models\CheckpointMesh_d.3d x=0 y=0 z=0 mlod=0
#exec mesh origin mesh=CheckpointMesh x=0 y=0 z=0 YAW=96
#exec mesh sequence mesh=CheckpointMesh seq=All startframe=0 numframes=1

#exec meshmap new meshmap=CheckpointMesh mesh=CheckpointMesh
#exec meshmap scale meshmap=CheckpointMesh x=0.03320 y=0.03320 z=0.06641

//var vector OrgLocation;       // Original Player Location
//var rotator OrgRotation;      // Original Player Rotation
var Pawn P;
var bool bDisabled;
var float LastSpawnTime, Interval;

function PostBeginPlay() 
{
	if ( Pawn(Owner) != None && Pawn(Owner).PlayerReplicationInfo != None )
	{
		P = Pawn(Owner);
		log (Self.Name$" has been spawned for "$P.GetHumanName(),'Ns_SpawnPoint');
		Interval = 10.000000;
			InitialState = 'SpawnTracking';
	}
}

function UpdateMe()
{
	local Teleporter T;

	if ( P == None )
		GoTo NullUpdate;
	if((P.Region.Zone != none) && (!P.Region.Zone.bWaterZone) && (!P.Region.Zone.bPainZone) &&
		(!P.Region.Zone.bKillZone) && (!P.Region.Zone.isA('WarpZone')) && (!P.Region.Zone.isA('TeleporterZone')) &&
		(!P.Region.Zone.isA('VacuumZone')) && (P.health >= 1) && (!P.PlayerReplicationInfo.bWaitingPlayer) &&
		(P.Physics != PHYS_Falling) && (P.Physics != PHYS_Swimming) && (P.Physics != PHYS_Flying) &&
		(P.Base != none) && (!P.Base.isA('Mover') && P.PlayerReplicationInfo.HasFlag == None )
		&& !NearbyMonsters(P))
		{
			if ( Interval < 10 )
				Interval = 10.000000;
			bDisabled = False;
			foreach RadiusActors(class'Teleporter', T, 50, P.Location)   //too close to teleporter
				return;
			SetLocation(P.Location+vect(0,0,-38));
			SetRotation(P.Rotation);
		}
		else
		{
			if ( Interval > 1.000000 )
				Interval = 1.000000;
		}
NullUpdate:
}

final function TrackMovement()
{
	if ( P == None || P.bDeleteMe || Level.Game.bGameEnded )
	{
		GotoState('SpawnTracking','FinishHim');
		GoTo EndTrack;
	}
	UpdateMe();

	if ( Bot(P) != None && P.Health > 0)
	{
		if ( P.Region.Zone.bWaterZone && P.Physics != PHYS_Swimming )
			P.SetPhysics(PHYS_Swimming);
		if ( P.MoveTarget != None && LiftCenter(P.MoveTarget) == None && Mover(P.Base) == None )
		{
			if (!FastTrace(P.Location+vect(0,0,-30),P.MoveTarget.Location))
				Bot(P).BigJump(P.MoveTarget);
		}
	}
EndTrack:
}

final function bool NearbyMonsters(Actor A)
{
	local bool bResult;
	local Pawn P1;

	if ( A == None )
	{
		bResult = False;
		GoTo Resulting;
	}

	if (P == None || P.bDeleteMe)
	{
		bResult = False;
		GoTo Resulting;
	}

	foreach RadiusActors(class 'Pawn',P1,700,Location)
	{
		if (P1 != P && P.DrawType == DT_Mesh && P1.Mesh != None && !P1.bHidden )
		{
			if ( P1.PlayerReplicationInfo == None && FastTrace( A.Location+vect(0,0,30),P1.Location ) )
			{
				bResult = True;
				break;
			}
		}
	}
Resulting:
	return bResult;
}

final function bool NearbyPlayers(Actor A)
{
	local bool bResult;
	local Pawn P1;

	if ( A == None )
	{
		bResult = False;
		GoTo Resulting;
	}

	if (P == None || P.bDeleteMe)
	{
		bResult = False;
		GoTo Resulting;
	}

	foreach RadiusActors(class 'Pawn',P1,160,A.Location)
	{
		if ( P1 != P && P1.DrawType == DT_Mesh
		&& P1.Mesh != None && !P1.bHidden
		&& P1.PlayerReplicationInfo != None )
		{
			if ( P1.PlayerReplicationInfo == None  )
			{
				bResult = True;
				break;
			}
		}
	}
Resulting:
	return bResult;
}

state() SpawnTracking
{
Begin:
	Mesh = Mesh'CheckpointMesh';
	Sleep(0.00);
	MultiSkins[1] = Pawn(Owner).PlayerReplicationInfo.TalkTexture;
	Sleep(0.00);
	log (Self.Name$" is initialized and tracking ready...",'Ns_SpawnPoint');
	Sleep(0.1);
LoopTrack:
	if ( P == None || P.bDeleteMe )
		GoTo('FinishHim');
	TrackMovement();
	Sleep(Interval);
	Goto('LoopTrack');
FinishHim:
	LifeSpan = 0.08;
	GoToState('');
}

defaultproperties
{
	Drawscale=0.5
	bOnlyOwnerSee=True
	Mesh=Mesh'CheckpointMesh'
	Skin=Texture'Botpack.FacePanel0'
	DrawType=DT_Mesh
	Style=STY_Translucent
	ScaleGlow=210
	bUnlit=True
	bStatic=False
	bCollideActors=False
	bCollideWhenPlacing=False
	CollisionRadius=17.000000
	CollisionHeight=39.000000
	RemoteRole=ROLE_DumbProxy
	NetUpdateFrequency=3.000000
	MultiSkins(0)=Texture'BotPack.Icons.HudLine'
	MultiSkins(1)=Texture'DefaultCpoint'
}
